(**************************************************************)
(*
 *  Ensemble, (Version 0.40)
 *  Copyright 1997 Cornell University
 *  All rights reserved.
 *
 *  See ensemble/doc/license.txt for further information.
 *)
(**************************************************************)
(**************************************************************)
(* ENV.ML: OS dependent stuff *)
(* Author: Takako M. Hickey, 4/97 *)
(**************************************************************)
open Unix;;

(* Bypass the type system *)
external fd_of_int : int -> file_descr = "%identity";;
external int_of_fd : file_descr -> int = "%identity";;

(**************************************************************)
(* TODO: decide what information to send.  Which load?  Truncate?
 *)
let get_load () = (
  let load = ref 0.0 in
  let chan = Unix.open_process_in "uptime | awk '{ print $11 }' | sed -e 's,\,,,g'" in
  (try
     load := float_of_string (input_line chan)
  with
     End_of_file -> ()
  ) ;
  Unix.close_process_in chan ;
  !load
)

(*
let get_load_list () = (
  let chan = Unix.open_process_in
    "uptime | awk '{ print $10 \" \" $11 \" \" $12}' | sed -e 's,\,,,g'"
  in
  let s = (input_line chan) in
  Unix.close_process_in chan ;
  let l= Str.split (regexp "[ ]+") s in
  let load = ref [] in
  (try
    load := List.map float_of_string l
  with End_of_file -> ()) ;
  !load
)
*)
